#property copyright "*"
#property link      "*"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 DodgerBlue

#property indicator_width1 5
#property indicator_width2 5

extern bool   Alert_ON=false;
extern string sx0="==============================";
extern double k1=1.0;
extern double k2=3.0;
extern double k3=6.0;
extern double k4=24.0;
extern int  FromAr=25;
extern int  UpArCode=241;
extern int  DnArCode=242;
extern int Pr=0;

//---- buffers

double A1[];
double A2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,UpArCode);
   SetIndexBuffer(0,A1);
   
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,DnArCode);
   SetIndexBuffer(1,A2);  
   
   SetIndexLabel(0,"GMA Quadro SUM");
   SetIndexLabel(1,"GMA Quadro SUM");   
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start(){
  double m;
  double c,p;
   int limit=Bars-IndicatorCounted();
      for(int i=limit-1;i>=0;i--){
         c=IndVal(k4,i)+IndVal(k3,i)+IndVal(k2,i)+IndVal(k1,i);         
         p=IndVal(k4,i+1)+IndVal(k3,i+1)+IndVal(k2,i+1)+IndVal(k1,i+1);
         
         A1[i]=EMPTY_VALUE;
         A2[i]=EMPTY_VALUE; 
         
         if(c>0 && p<=0)A1[i]=Low[i]-Point*FromAr;
         if(c<0 && p>=0)A2[i]=High[i]+Point*FromAr;         
                 
         
      }
      
      static int lt1,lt2;
      if(Alert_ON){
         if(A1[1]!=EMPTY_VALUE && lt1!=Time[0]){
            lt1=Time[0];
            Alert("GMA Quadro SUM("+Symbol()+"-"+TimeFrameName(Period())+"): Buy Arrow");
         }
         if(A2[1]!=EMPTY_VALUE && lt2!=Time[0]){
            lt2=Time[0];
            Alert("GMA Quadro SUM("+Symbol()+"-"+TimeFrameName(Period())+"): Sell Arrow");
         } 
      }      
      
   return(0);
  }
//+------------------------------------------------------------------+

double IndVal(double Koef,int Ind){
   double c=0;
   double m=0;
      m=iMACD(NULL,0,Koef*3,Koef*30,9,Pr,MODE_MAIN,Ind);
         if(m>0)c++;
         if(m<0)c--;         
      m=iMACD(NULL,0,Koef*5,Koef*35,9,Pr,MODE_MAIN,Ind);
         if(m>0)c++;
         if(m<0)c--;                    
      m=iMACD(NULL,0,Koef*8,Koef*40,9,Pr,MODE_MAIN,Ind);
         if(m>0)c++;
         if(m<0)c--;          
      m=iMACD(NULL,0,Koef*10,Koef*45,9,Pr,MODE_MAIN,Ind);
         if(m>0)c++;
         if(m<0)c--;   
      m=iMACD(NULL,0,Koef*12,Koef*50,9,Pr,MODE_MAIN,Ind);
         if(m>0)c++;
         if(m<0)c--;
      m=iMACD(NULL,0,Koef*15,Koef*60,9,Pr,MODE_MAIN,Ind);
         if(m>0)c++;
         if(m<0)c--;
   return(c);  
}

string TimeFrameName(int arg){
   int v;
      if(arg==0){
         v=Period();
      }
      else{
         v=arg;
      }
      switch(v){
         case 0:
            return("0");
         case 1:
            return("M1");
         case 5:
            return("M5");                  
         case 15:
            return("M15");
         case 30:
            return("M30");             
         case 60:
            return("H1");
         case 240:
            return("H4");                  
         case 1440:
            return("D1");
         case 10080:
            return("W1");          
         case 43200:
            return("MN1");
         default:
            return("Wrong TimeFrame");          
      }
}